package com.gx.obe.component.tabfolder;

import java.util.Objects;
import java.util.Optional;
import java.util.function.Function;

import org.eclipse.swt.widgets.Composite;

import com.gx.obe.bind.view.ChangeListener;
import com.gx.obe.bind.view.RView;

/**
 * @Description: 选项卡布局
 * @author chenxw
 * @param <T>
 */
public abstract class FTabFolder<T> extends CTabFolder implements RView<T> {
	
	private ChangeListener changeListener;
	
	private RView<T> rView;
	
	/**
	 * @author chenxw
	 * @param parent
	 * @param style
	 */
	public FTabFolder(Composite parent, int style) {
		super(parent, style);
	}
	
	@Override
	public void addChangeListener(ChangeListener changeListener) {
		this.changeListener = Objects.requireNonNull(changeListener);
		notifyMouseUp();
	}
	
	@Override
	public T get() {
		return Optional.ofNullable(rView).map(RView::get).orElse(null);
	}
	
	/**
	 * @Description: 选项卡
	 * @author chenxw
	 */
	protected class FTabItem extends CTabFolder.CTabItem {
		
		/**
		 * @author chenxw
		 * @param text
		 * @param function
		 */
		public FTabItem(String text) {
			super(text);
		}
		
		/**
		 * @Description:
		 * @author chenxw
		 * @param function
		 */
		public void action(Function<Composite, RView<T>> function) {
			super.action(t -> {
				rView = function.apply(t);
				rView.addChangeListener(changeListener);
				changeListener.change();
			});
		}
		
	}
	
}
